angular.module('findit', ['ionic',  'findit.controllers', 'findit.services','findit.directives', 'monospaced.elastic', 'ngCordova']) //ionicLazyLoad
  .config(['$ionicConfigProvider', function($ionicConfigProvider) {
    $ionicConfigProvider.tabs.position('bottom'); // other values: top
  }])
//.run(function($ionicPlatform,$rootScope,Setting,ls) {
  .run(function ($ionicPlatform, $rootScope,$ionicActionSheet, $timeout,  $cordovaAppVersion, $ionicPopup, $ionicLoading, $cordovaFileTransfer, $cordovaFile, $cordovaFileOpener2,Setting,ls,ss,Private) {

  $ionicPlatform.ready(function() {

    //function getLocationRoot() {
    //  var q = $q.defer();
    //
    //  navigator.geolocation.getCurrentPosition(function(position) {
    //    q.resolve(position);
    //  }, function(error) {
    //    q.reject(error);
    //    console.log("Errore posizione " + error.code + "-" + error.message );
    //  });
    //  return q.promise;
    //};


    /*提前获取地理位置开始*/
    ////document.addEventListener("deviceready", onDeviceReady, false);
    ////function onDeviceReady() {
    //  navigator.geolocation.getCurrentPosition(onSuccess, onError);
    ////}
    //
    //// onSuccess Geolocation
    ////
    //function onSuccess(position) {
    //  latitude = position.coords.latitude;
    //  longitude = position.coords.longitude;
    //  angular.bootstrap(document, ['findit']);
    //  //alert("latitude:" + latitude + "longitude:" + longitude);
    //}
    //// onError Callback receives a PositionError object
    ////
    //function onError(error) {
    //  alert('code: '    + error.code    + '\n' +
    //    'message: ' + error.message + '\n');
    //  angular.bootstrap(document, ['findit']);
    //}
    /*提前获取地理位置结束*/

    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
      cordova.plugins.Keyboard.disableScroll(false);

    }
    if (window.StatusBar) {
      // org.apache.cordova.statusbar required
      StatusBar.styleDefault();
    }

    //  //版本号获取
    //cordova.getAppVersion(function(currentVersion) {
    //    //取服务器上最新版本
    //  $rootScope.currentVer = currentVersion;
    //  Setting.all(function(items) {
    //    $rootScope.latestVer = items.data.version;
    //    if (currentVersion <  items.data.version)
    //    {
    //      $rootScope.hasNewVer = true;
    //    }
    //  });
    //});

    // 首次运行时开启通知，之后只能通过 设置 通知 中更改
    //window.plugin.notification.local.hasPermission(function (granted) {
    //  if(!granted) {
    //    window.plugin.notification.local.promptForPermission();
    //  }
    //});

    //检测更新
    checkUpdate();
    document.addEventListener("menubutton", onHardwareMenuKeyDown, false);

    //昵称设置
    if (ls.get("myNickName") == undefined){
      var randomNumber = Math.floor(Math.random() * ( findItApp.nickNames.length));
      ls.set("myNickName", findItApp.nickNames[randomNumber]);
    }

    //获取IP
    Private.ip(function(params) {
      ss.set("myIp", params.data.ip);
    });
  });

    // 菜单键
    function onHardwareMenuKeyDown() {
      $ionicActionSheet.show({
        titleText: '检查更新',
        buttons: [
          { text: '关于' }
        ],
        destructiveText: '检查更新',
        cancelText: '取消',
        cancel: function () {
          // add cancel code..
        },
        destructiveButtonClicked: function () {
          //检查更新
          checkUpdate();
        },
        buttonClicked: function (index) {

        }
      });
      $timeout(function () {
        hideSheet();
      }, 2000);
    };

    // 检查更新
    function checkUpdate() {
      Setting.all(function(items) {
        var serverAppVersion = items.data.version; //从服务端获取最新版本
        var serverAppDescription = items.data.description;
        var serverAppUrl = items.data.appurl;
        var localAppUrl = items.data.localurl;
        var priority = items.data.priority;
        $rootScope.latestVer = serverAppVersion;
        $rootScope.weixinhao = items.data.weixinhao;
        $rootScope.youxianghao = items.data.youxianghao;
        $rootScope.zhibohao = items.data.zhibohao;
        $rootScope.qunhao = items.data.qunhao;
        $rootScope.badwords = items.data.badwords;

        //获取版本
        $cordovaAppVersion.getVersionNumber().then(function (version) {
          $rootScope.currentVer = version;
          //如果本地与服务端的APP版本不符合
          if (version < serverAppVersion) {
            if (priority < 2)
            {
              showUpdateConfirm(serverAppVersion,serverAppDescription,serverAppUrl,localAppUrl,priority);
            }
            $rootScope.hasNewVer = true ;
          } else {
            $rootScope.hasNewVer = false ;
          }
        });
      });
    }

    //function closeLoader(){
    //  $ionicLoading.hide();
    //}
    // 显示是否更新对话框
    function showUpdateConfirm(serverAppVersion,serverAppDescription,serverAppUrl, localAppUrl, prority) {
      var confirmPopup;
      if(prority == 0){
        confirmPopup = $ionicPopup.alert({
          title: '版本必须升级',
          template: serverAppDescription
        });
      }else{
        confirmPopup = $ionicPopup.confirm({
          title: '版本升级选择',
          template: serverAppDescription, //从服务端获取更新的内容
          cancelText: '下次再说',
          okText: '立刻升级'
        });
      }
      confirmPopup.then(function (res) {
        //if (res) {
        //  $ionicLoading.show({
        //    template: "已经下载：0%\n取消可点关闭<span style='line-height: normal' ng-click='closeLoader()'><i style='font-size: 30px;' class='icon ion-close-circled'></i></span>"
        //  });

          var url = serverAppUrl + "findit_v" + serverAppVersion + ".apk"; //可以从服务端获取更新APP的路径
          //var targetPath = localAppUrl + "findit_" + serverAppVersion + ".apk"; //APP下载存放的路径，可以使用cordova file插件进行相关配置

          if (res){
            window.open(url, '_system', 'location=yes');
          }

      //    var trustHosts = true
      //    var options = {};
      //    $cordovaFileTransfer.download(url, targetPath, options, trustHosts).then(function (result) {
      //      // 打开下载下来的APP
      //      $cordovaFileOpener2.open(targetPath, 'application/vnd.android.package-archive'
      //      ).then(function () {
      //        // 成功
      //      }, function (err) {
      //        // 错误
      //      });
      //      $ionicLoading.hide();
      //    }, function (err) {
      //      alert(JSON.stringify(err));
      //      alert('下载失败,请去"设置"栏目中"检查新版本"里直接下载，或去安卓应用市场下载最新版本。抱歉给您带来不好体验!');
      //      $ionicLoading.hide();
      //      $rootScope.hasNewVer = true;
      //      localStorage.setItem('hasUpdateError', true);
      //    }, function (progress) {
      //      //进度，这里使用文字显示下载百分比
      //      $timeout(function () {
      //        var downloadProgress = (progress.loaded / progress.total) * 100;
      //        $ionicLoading.show({
      //          template: "<ion-spinner icon='ios-small'></ion-spinner><br/>已经下载：" + Math.floor(downloadProgress) + "%\n取消可点关闭<span style='line-height: normal' ng-click='closeLoader()'><i style='font-size: 30px;' class='icon ion-close-circled'></i></span>"
      //        });
      //        if (downloadProgress > 99) {
      //          $ionicLoading.hide();
      //        }
      //      })
      //    });
      //  } else {
      //    $rootScope.hasNewVer = true;
      //  }
      });
    }
})
  //加上如下代码就没有ion-item切换之间的动画了
.config(function($ionicConfigProvider) {
  $ionicConfigProvider.views.transition('none');
})
.config(function($stateProvider, $urlRouterProvider,$ionicConfigProvider) {

  $ionicConfigProvider.platform.ios.tabs.style('standard');
  $ionicConfigProvider.platform.ios.tabs.position('bottom');
  $ionicConfigProvider.platform.android.tabs.style('standard');
  $ionicConfigProvider.platform.android.tabs.position('bottom');

  $ionicConfigProvider.platform.ios.navBar.alignTitle('center');
  $ionicConfigProvider.platform.android.navBar.alignTitle('center');

  $ionicConfigProvider.platform.ios.backButton.previousTitleText('').icon('ion-ios-arrow-thin-left');
  $ionicConfigProvider.platform.android.backButton.previousTitleText('').icon('ion-android-arrow-back');

  $ionicConfigProvider.platform.ios.views.transition('ios');
  $ionicConfigProvider.platform.android.views.transition('android');

  // Ionic uses AngularUI Router which uses the concept of states
  // Learn more here: https://github.com/angular-ui/ui-router
  // Set up the various states which the app can be in.
  // Each state's controller can be found in controllers.js
  $stateProvider

  // setup an abstract state for the tabs directive
    .state('tab', {
    url: '/tab',
    abstract: true,
    templateUrl: 'templates/tabs.html'
  })

  // Each tab has its own nav history stack:

  .state('tab.finding', {
    url: '/finding',
    views: {
      'tab-finding': {
        templateUrl: 'templates/tab-finding.html',
        controller: 'FindingCtrl'
      }
    }
  })

  .state('tab.article', {
      url: '/article',
      views: {
        'tab-article': {
          templateUrl: 'templates/tab-article.html',
          controller: 'ArticleCtrl'
        }
      }
    })
    .state('tab.article-detail', {
      url: '/article/:articleId',
      views: {
        'tab-article': {
          templateUrl: 'templates/article-detail.html',
          controller: 'ArticleDetailCtrl'
        }
      }
    })
    .state('tab.spot-comment', {
      url: '/finding/comment/:spotId/:keyId',
      views: {
        'tab-finding': {
          templateUrl: 'templates/spot-comment.html',
          controller: 'SpotCommentCtrl'
        }
      }
    })
    .state('tab.spot-detail', {
      cache: false,
      url: '/finding/:spotId',
      views: {
        'tab-finding': {
          templateUrl: 'templates/spot-detail.html',
          controller: 'SpotDetailCtrl'
        }
      }
    })
    .state('tab.spot-image', {
      cache: false,
      url: '/finding/:spotId/image',
      views: {
        'tab-finding': {
          templateUrl: 'templates/spot-image.html',
          controller: 'SpotImageCtrl'
        }
      }
    })
    .state('tab.spot-location', {
      url: '/finding/:spotId/location',
      views: {
        'tab-finding': {
          templateUrl: 'templates/spot-location.html',
          controller: 'SpotLocationCtrl'
        }
      }
    })
    .state('tab.spot-map', {
      cache: false,
      url: '/finding/:spotId/:typeId',
      views: {
        'tab-finding': {
          templateUrl: 'templates/spot-map.html',
          controller: 'SpotMapCtrl'
        }
      }
    })
    .state('tab.setting', {
      url: '/setting',
      views: {
        'tab-profile': {
          templateUrl: 'templates/tab-setting.html',
          controller: 'SettingCtrl'
        }
      }
    })
    .state('tab.setting-feedback', {
      url: '/setting/feedback',
      views: {
        'tab-profile': {
          templateUrl: 'templates/setting-feedback.html',
          controller: 'SettingFeedCtrl'
        }
      }
    })
    .state('tab.setting-howto', {
      url: '/setting/howto',
      views: {
        'tab-profile': {
          templateUrl: 'templates/setting-howto.html',
          controller: 'SettingHowtoCtrl'
        }
      }
    })
    .state('tab.setting-contact', {
      url: '/setting/contact',
      views: {
        'tab-profile': {
          templateUrl: 'templates/setting-contact.html',
          controller: 'SettingContactCtrl'
        }
      }
    })
    .state('tab.spot-favorite', {
      cache: false,
      url: '/profile/favorite',
      views: {
        'tab-profile': {
          templateUrl: 'templates/spot-favorite.html',
          controller: 'SpotFavoriteCtrl'
        }
      }
    })
    .state('tab.spot-comment2', {
      url: '/setting/comment/:spotId/:keyId',
      views: {
        'tab-profile': {
          templateUrl: 'templates/setting-comment.html',
          controller: 'SpotCommentCtrl'
        }
      }
    })
    .state('tab.spot-detail2', {
      cache: false,
      url: '/setting/:spotId',
      views: {
        'tab-profile': {
          templateUrl: 'templates/setting-detail.html',
          controller: 'SpotDetailCtrl'
        }
      }
    })
    .state('tab.spot-image2', {
      cache: false,
      url: '/setting/:spotId/image',
      views: {
        'tab-profile': {
          templateUrl: 'templates/spot-image.html',
          controller: 'SpotImageCtrl'
        }
      }
    })
    .state('tab.spot-location2', {
      url: '/setting/:spotId/location',
      views: {
        'tab-profile': {
          templateUrl: 'templates/spot-location.html',
          controller: 'SpotLocationCtrl'
        }
      }
    })
    .state('tab.spot-map2', {
      cache: false,
      url: '/setting/:spotId/:typeId',
      views: {
        'tab-profile': {
          templateUrl: 'templates/spot-map.html',
          controller: 'SpotMapCtrl'
        }
      }
    })
    .state('tab.chat-log', {
      cache: false,
      url: '/chat-log',
      views: {
        'tab-chat': {
          templateUrl: 'templates/chat-login.html',
          controller: 'ChatLogCtrl'
        }
      }
    })
    .state('tab.chat-reg', {
      cache: false,
      url: '/chat-reg',
      views: {
        'tab-chat': {
          templateUrl: 'templates/chat-register.html',
          controller: 'ChatRegCtrl'
        }
      }
    })
    .state('tab.chat-home', {
      cache: false,
      url: '/chat-home',
      views: {
        'tab-chat': {
          templateUrl: 'templates/chat-detail.html',
          controller: 'ChatHomeCtrl'
        }
      }
    })
    .state('tab.chat-position', {
      cache: false,
      url: '/chat-position', //:userInfo
      views: {
        'tab-chat': {
          templateUrl: 'templates/chat-position.html',
          controller: 'ChatPosCtrl'
        }
      }
    })
    .state('tab.chat-checkpos', {
      cache: false,
      url: '/chat-checkpos/:posInfo',
      views: {
        'tab-chat': {
          templateUrl: 'templates/chat-checkpos.html',
          controller: 'ChatChkPosCtrl'
        }
      }
    })
    .state('tab.profile', {
      cache: false,
      url: '/profile',
      views: {
        'tab-profile': {
          templateUrl: 'templates/tab-profile.html',
          controller: 'ProfileCtrl'
        }
      }
    })
    .state('tab.profile-update', {
    url: '/profile/update/:keyId/:city/:name/:phone',
    views: {
      'tab-profile': {
        templateUrl: 'templates/profile-update.html',
        controller: 'ProfileUpdateCtrl'
      }
    }
  });

    // if none of the above states are matched, use this as the fallback
    $urlRouterProvider.otherwise('/tab/finding');

});

//ionic.Platform.ready(function() {
//  alert("device ready!!");
//
//});

